#include <QPainter>
#include <QTimer>
#include <QThread>
#include <qdatetime.h>

#include "tut.h"


Blaa::Blaa(QObject* parent, QMutex* mutex, QImage **img) : QThread(parent), mutex(mutex), img(img)
{
  time2die = false;
}
Tutorial1::Tutorial1(QObject *parent, const QVariantList &args)
        : Plasma::Wallpaper(parent, args), mutex(new QMutex), blaa(parent, mutex, &img)
{
  img = NULL;
  mutex = new QMutex;
  blaa.start();
}
Tutorial1::~Tutorial1()
{
}

void Blaa::SaveFrame(int width, int height)
{
  mutex->lock();
    if (!*img)
    {
      *img = new QImage(QSize(width, height), QImage::Format_RGB888);
    }
  uint8_t *data = (*img)->bits();
    for (int y = 0; y < height; y++)
    {
      for (int x = 0; x < width; x++)
      {
        data[0] = 0;
        data[1] = 255;
        data[2] = 0;
        data += 3;
      }
    }
  mutex->unlock();
}

void Tutorial1::updator()
{
  emit(update(boundingRect()));
}

void Tutorial1::paint(QPainter *painter, const QRectF& exposedRect)
{
    mutex->lock();
    if (img)
      painter->drawImage(boundingRect(), *img);
    mutex->unlock();
}

void Blaa::run()
{
  // Read frames and save first five frames to disk
  while (!time2die) {
          SaveFrame(800, 600);
          sleep(1);
    }

}

#include "tut.moc"
