#include <QPainter>
#include <QTimer>
#include <QThread>
#include <qdatetime.h>

#include "tut.h"


Blaa::Blaa(QObject* parent, Tutorial1* tis) : QThread(parent), is(tis)
{
  time2die = false;
}
Tutorial1::Tutorial1(QObject *parent, const QVariantList &args)
        : Plasma::Wallpaper(parent, args), blaa(parent, this), img(NULL)
{
  currvid = -1;
  //playlist.push_back("/home/genjix/media/videos/genius party/[BSS]_Genius_Party_-_01_[Genius_Party][h264][2A79E082].mkv");
  //playlist.push_back("/home/genjix/Desktop/moto.avi");
  playlist.push_back("/home/genjix/media/videos/[BSS]_Genius_Party_Beyond_[DVD]/[BSS]_Genius_Party_Beyond_-_Dimension_Bomb_[1DB25A30].mkv");
  //playlist.push_back("/home/genjix/Desktop/video.avi");
  //playlist.push_back("/home/genjix/media/videos/What about Bob.avi");
  pCodec = NULL;
  pFrame = NULL;
  pFrameRGB = NULL;
  buffer = NULL;
  pCodecCtx = NULL;
  pFormatCtx = NULL;
  frameFinished = 0;
  numBytes = 0;
  video_index = 0;
  //time = 0;
  f = NULL;
  //connect(&timer, SIGNAL(timeout()), this, SLOT(updator()));
  //timer.setSingleShot(true);
  mutex = new QMutex;
  blaa.start();
}
Tutorial1::~Tutorial1()
{
//  DeInit();
}

void Tutorial1::Init()
{
  if (currvid < 0)
    return;
  // Register all formats and codecs
  av_register_all();

  // Open video file
  if(av_open_input_file(&pFormatCtx, playlist[currvid].c_str(), NULL, 0, NULL)!=0)
    return; // Couldn't open file

  // Retrieve stream information
  if(av_find_stream_info(pFormatCtx)<0)
    return; // Couldn't find stream information

  // Dump information about file onto standard error
  //dump_format(pFormatCtx, 0, argv[1], 0);

  // Find the first video stream
  video_index=-1;
  for(int i=0; i<pFormatCtx->nb_streams; i++)
  {
    if(pFormatCtx->streams[i]->codec->codec_type==CODEC_TYPE_VIDEO) {
      video_index=i;
      break;
    }
  }
  if(video_index==-1)
    return; // Didn't find a video stream

  // Get a pointer to the codec context for the video stream
  pCodecCtx=pFormatCtx->streams[video_index]->codec;

  // Find the decoder for the video stream
  pCodec=avcodec_find_decoder(pCodecCtx->codec_id);
  if(pCodec==NULL) {
    fprintf(stderr, "Unsupported codec!\n");
    return; // Codec not found
  }
  // Open codec
  if(avcodec_open(pCodecCtx, pCodec)<0)
    return; // Could not open codec

  // Allocate video frame
  pFrame=avcodec_alloc_frame();

  // Allocate an AVFrame structure
  pFrameRGB=avcodec_alloc_frame();
  if(pFrameRGB==NULL)
    return;

  // Determine required buffer size and allocate buffer
  numBytes=avpicture_get_size(PIX_FMT_RGB24, pCodecCtx->width,
                  pCodecCtx->height);
  buffer=(uint8_t *)av_malloc(numBytes*sizeof(uint8_t));

  // Assign appropriate parts of buffer to image planes in pFrameRGB
  // Note that pFrameRGB is an AVFrame, but AVFrame is a superset
  // of AVPicture
  avpicture_fill((AVPicture *)pFrameRGB, buffer, PIX_FMT_RGB24,
         pCodecCtx->width, pCodecCtx->height);

  //clock.start();

  //time = 0;
  f = fopen("/home/genjix/out", "a");
}
void Tutorial1::DeInit()
{
  blaa.time2die = true;
  blaa.wait();
  mutex->lock();
  delete img;

  if (pFormatCtx)
  {
    // Free the RGB image
    av_free(buffer);
    av_free(pFrameRGB);

    // Free the YUV frame
    av_free(pFrame);

    // Close the codec
    avcodec_close(pCodecCtx);

    // Close the video file
    av_close_input_file(pFormatCtx);
  }

  img = NULL;
  pCodec = NULL;
  pFrame = NULL;
  pFrameRGB = NULL;
  buffer = NULL;
  pCodecCtx = NULL;
  pFormatCtx = NULL;
  frameFinished = 0;
  numBytes = 0;
  video_index = 0;
  //time = 0;
  f = NULL;
  mutex->unlock();
  delete mutex;
}

void Blaa::SaveFrame(AVFrame *pFrame, int width, int height)
{
  is->mutex->lock();
    if (!is->img)
    {
      is->img = new QImage(QSize(is->pCodecCtx->width, is->pCodecCtx->height), QImage::Format_RGB888);
    }
  uint8_t *data = is->img->bits();
    for (int y = 0; y < height; y++)
    {
      uint8_t* line = pFrame->data[0] + y*pFrame->linesize[0];
      for (int x = 0; x < width; x++)
      {
        char r = line[x*3], g = line[x*3 + 1], b = line[x*3 + 2];
        data[0] = r;
        data[1] = g;
        data[2] = b;
        data += 3;
      }
    }
  is->mutex->unlock();
}

void Tutorial1::run()
{
}

void Tutorial1::updator()
{
  emit(update(boundingRect()));
}

void Tutorial1::paint(QPainter *painter, const QRectF& exposedRect)
{
    mutex->lock();
    if (img)
    {
      painter->drawImage(boundingRect(), *img);
      mutex->unlock();
    }
    else
    {
      mutex->unlock();
      painter->setBrush(Qt::black);
      painter->drawRect(boundingRect());
    }
}

void Blaa::run()
{
  /*int64_t seek_target = time * AV_TIME_BASE/1000;
  if(video_index>=0){
    seek_target= av_rescale_q(seek_target, AV_TIME_BASE_Q,
                      pFormatCtx->streams[video_index]->time_base);
  }
  if(av_seek_frame(pFormatCtx, video_index,
                    seek_target, 0) < 0) {
    fprintf(stderr, "%s: error while seeking\n",
            pFormatCtx->filename);
  }*/

  is->currvid++;
  is->Init();
  // Read frames and save first five frames to disk
  while (!time2die) {

    /*is->currvid++;
    is->Init();
    if (is->currvid > is->playlist.size())
    {
      if (is->playlist.size() == 0)
      {
        is->currvid = -1;
        sleep(4);
      }
      else
        is->currvid = 0;
    }*/

  while (!time2die && is->pFormatCtx && av_read_frame(is->pFormatCtx, &(is->packet))>=0) {
    // Is this a packet from the video stream?
    if(is->packet.stream_index==is->video_index) {
      // Decode video frame
      avcodec_decode_video(is->pCodecCtx, is->pFrame, &(is->frameFinished),
               is->packet.data, is->packet.size);

      // Did we get a video frame?
      if(is->frameFinished) {
      SwsContext *img_convert_ctx = sws_getContext(is->pCodecCtx->width, is->pCodecCtx->height,
          is->pCodecCtx->pix_fmt,
          is->pCodecCtx->width, is->pCodecCtx->height,
          PIX_FMT_RGB24,
          SWS_BILINEAR|SWS_CPU_CAPS_MMX, NULL, NULL, NULL);

  //uint8_t *data = is->img->bits();
  //int linesize = is->pCodecCtx->width;

      sws_scale(img_convert_ctx, is->pFrame->data,
          is->pFrame->linesize, 0, is->pCodecCtx->height,
          is->pFrameRGB->data, is->pFrameRGB->linesize);
          //&data, &linesize);

      sws_freeContext(img_convert_ctx);

          SaveFrame(is->pFrameRGB, is->pCodecCtx->width, is->pCodecCtx->height);
    //int elapsed = is->clock.elapsed();
          is->updator();
          //is->timer.start(60);
          //int elapsed = is->clock.elapsed();
          const AVRational &a = is->pCodecCtx->time_base;
          //double fps = av_q2d(pCodecCtx->timebase);
          // lets roll ours own q2d since theirs sucks so bad
          int spf = (1000000000 * a.num) / (double) a.den;
          if (!time2die)
            QThread::usleep(spf);
      }
    }

    // Free the packet that was allocated by av_read_frame
    av_free_packet(&(is->packet));
  }
  av_seek_frame(is->pFormatCtx, is->video_index, 0, AVSEEK_FLAG_BACKWARD|AVSEEK_FLAG_BYTE);

  /*is->mutex->lock();
  is->DeInit();
  is->mutex->unlock();*/
  if (!time2die)
    sleep(1);
}

}

TheGayWidget::TheGayWidget(QWidget* parent)
{
  setupUi(this);
}

#include "tut.moc"
