#ifndef PLASMA_WALLPAPER_TUTORIAL1
#define PLASMA_WALLPAPER_TUTORIAL1

#include <Plasma/Wallpaper>
#include <stdint.h>
#include <QMutex>
#include <QWaitCondition>
#include <vector>
#include <queue>
#include <string>
#include <keditlistbox.h>

extern "C"
{
  #include <libavcodec/avcodec.h>
  #include <libavformat/avformat.h>
  #include <libswscale/swscale.h>
}

#include "ui_untitled.h"

class Tutorial1;

class Blaa : public QThread
{
  Q_OBJECT
  public:
    Blaa(QObject* parent, Tutorial1* tis);
    void SaveFrame(AVFrame *pFrame, int width, int height);
    void run();
  Tutorial1* is;
  bool time2die;
};

class TheGayWidget : public QWidget, private Ui_Form
{
  Q_OBJECT
  public:
    TheGayWidget(QWidget* parent = 0);
};

class Tutorial1 : public Plasma::Wallpaper
{
    Q_OBJECT
    public:
        Tutorial1(QObject* parent, const QVariantList& args);
        ~Tutorial1();
        void Init();
        void DeInit();
        void paint(QPainter* painter, const QRectF& exposedRect);
        void run();
    public Q_SLOTS:
        void updator();
    public:

  QWidget *createConfigurationInterface(QWidget *parent)
  {
    return new TheGayWidget(parent);
  }

        QImage *img;
  AVCodec         *pCodec;
  AVFrame         *pFrame;
  AVFrame         *pFrameRGB;
  uint8_t         *buffer;
  AVCodecContext  *pCodecCtx;
  AVFormatContext *pFormatCtx;
  AVPacket        packet;
  int             frameFinished;
  int             numBytes;
  int video_index;
  //QTime clock;
  //QTimer timer;
  FILE *f;
  Blaa blaa;
  QMutex* mutex;
  std::queue<QImage> images;
  std::vector<std::string> playlist;
  int currvid;
};

K_EXPORT_PLASMA_WALLPAPER(tut, Tutorial1)

#endif
